-- Insert a tab into MCM
Mods.BG3MCM.IMGUIAPI:InsertModMenuTab(ModuleUUID, "Inserted tab", function(tabHeader)
    local myCustomWidget = tabHeader:AddButton("My Custom Widget")
    myCustomWidget.OnClick = function()
        _D("My custom widget was clicked!")
    end
    -- You can define all sorts of widgets here that might require more complex/custom logic.
    -- For practical purposes, you can basically treat it as you would treat a IMGUI window, but the elements will be added inside your mod's tab instead.
    -- For more reference, see Aahz's EasyCheat mod.
end)

-- Reuse a tab (just use the name of an existing tab)
Mods.BG3MCM.IMGUIAPI:InsertModMenuTab(ModuleUUID, "Widget showcasing", function(tabHeader)
    local myCustomWidget = tabHeader:AddButton("My Custom Widget (in an existing tab)")
    myCustomWidget.OnClick = function()
        _D("My custom widget was clicked! (from an existing tab)")
    end
end)

-- Listening to MCM events
-- This is how you can listen to MCM events and react to theM. This is useful if you want to react to changes in settings or other events.
-- This is a client-side event, so it should be placed in the BootstrapClient.lua file.
Ext.RegisterNetListener("MCM_Saved_Setting", function(call, payload)
    local data = Ext.Json.Parse(payload)
    -- Always check if the data is valid and is related to your mod (unless for some reason you want to listen to other mods' events)
    if not data or data.modGUID ~= ModuleUUID or not data.settingId then
        return
    end

    if data.settingId == "MyColorPicker" then
        _D(data.value)
    end
end)
